<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: DataStructure/LinkedList/LinkedList.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_61f8caed08096df072032ac640f6feca.html">DataStructure</a></li><li class="navelem"><a class="el" href="dir_fd352d12eaba61d3c6f72f29695996db.html">LinkedList</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">LinkedList.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="LinkedList_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef LINKED_LIST_HPP</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define LINKED_LIST_HPP</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// C++ Library includes</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// Project includes</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="LinkedListNode_8h.html">LinkedListNode.h</a>&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;../Interfaces/ILinearDataStructure.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NotImplementedException.h&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/InvalidIndexException.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NullptrException.h&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NotImplementedException.h&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/StructureFullException.h&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/StructureEmptyException.h&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/InvalidIndexException.h&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/ItemNotFoundException.h&quot;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NullptrException.h&quot;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &quot;../../Utilities/Logger.h&quot;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;../../Utilities/StringUtil.h&quot;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceDataStructure.html">DataStructure</a></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;{</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList</a> : <span class="keyword">public</span> <a class="code" href="classDataStructure_1_1ILinearDataStructure.html">ILinearDataStructure</a>&lt;T&gt;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="comment">/* Member Variables */</span></div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#ab34197960bb08dbc99a5860e6ce85017">   34</a></span>&#160;    <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* <a class="code" href="classDataStructure_1_1LinkedList.html#ab34197960bb08dbc99a5860e6ce85017">m_ptrFirst</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a8054e1e07e5ef51ca22feb5c7791f174">   36</a></span>&#160;    <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* <a class="code" href="classDataStructure_1_1LinkedList.html#a8054e1e07e5ef51ca22feb5c7791f174">m_ptrLast</a>;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#acf9282e10399d1caea2c8d661f39539f">   38</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1LinkedList.html#acf9282e10399d1caea2c8d661f39539f">m_itemCount</a>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="comment">/* Member Functions */</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList</a>();</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList</a>();</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> PushFront( T newData );</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> PushBack( T newData );</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> PushAt( T newItem, <span class="keywordtype">int</span> index );</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> PopFront();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> PopBack();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> PopAt( <span class="keywordtype">int</span> index );</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">virtual</span> T&amp; GetFront();</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">virtual</span> T&amp; GetBack();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">virtual</span> T&amp; GetAt( <span class="keywordtype">int</span> index );</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> Size() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> IsEmpty() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> Clear();</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">bool</span> IsInvalidIndex( <span class="keywordtype">int</span> index ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a3d2e8a26e30f6159f376b954e9a55d7e">   78</a></span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classDataStructure_1_1LinkedListTester.html">LinkedListTester</a>;</div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a09e5530081c238d8d84fbcef927c3937">   79</a></span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classDataStructure_1_1QueueTester.html">QueueTester</a>;</div>
<div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a2118df8846e43115775918f6749561cf">   80</a></span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classDataStructure_1_1StackTester.html">StackTester</a>;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;};</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment">/* ----------------------------------------------------------------------------- LinkedList */</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#aec101c4e329974968b4b84d576b1ce0b">   90</a></span>&#160;<a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::LinkedList</a>()</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;{</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    m_ptrFirst = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    m_ptrLast = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    m_itemCount = 0;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;}</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment">/* ---------------------------------------------------------------------------- ~LinkedList */</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00103"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a7b101ef3634be2bccdada451004683bb">  103</a></span>&#160;<a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::~LinkedList</a>()</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;{</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="comment">// TODO: Call Clear() once it is implemented</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    Clear();</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;}</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment">/* ---------------------------------------------------------------------------------- Clear */</span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a3e36058159064e79de937f72668973c2">  118</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::Clear</a>() <span class="comment">/*                                                  Clear */</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;{</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordflow">while</span> ( m_ptrFirst != <span class="keyword">nullptr</span> )</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    {</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordflow">if</span> ( m_itemCount == 1 )</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            <span class="keyword">delete</span> m_ptrFirst;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            m_ptrFirst = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            m_ptrLast = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            m_ptrFirst = m_ptrFirst-&gt;m_ptrNext;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            <span class="keyword">delete</span> m_ptrFirst-&gt;m_ptrPrev;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            m_ptrFirst-&gt;m_ptrPrev = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        }</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        m_itemCount--;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    }</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;}</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">/* ------------------------------------------------------------------------------ PushFront */</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00173"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#ae1f18cd5777e9298c7cc359a45ff43cf">  173</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::PushFront</a>( T newData )</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;{</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;PushFront&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* newNode = <span class="keyword">new</span> <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>();</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a459aed18dba2dd2715819449b41e8b90">m_data</a> = newData;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160; </div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordflow">if</span> ( IsEmpty() )</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    {</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        m_ptrFirst = newNode;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        m_ptrLast = newNode;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    }</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    {</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        m_ptrFirst-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a> = newNode;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a> = m_ptrFirst;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        m_ptrFirst = newNode;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    }</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160; </div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    m_itemCount++;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;}</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160; </div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160; </div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="comment">/* ------------------------------------------------------------------------------- PushBack */</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00228"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#afb7f96a2520158ee154afbc7f947a5af">  228</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::PushBack</a>( T newData )</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;{</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;PushBack&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* newNode = <span class="keyword">new</span> <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>();</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a459aed18dba2dd2715819449b41e8b90">m_data</a> = newData;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160; </div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <span class="keywordflow">if</span> ( IsEmpty() )</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    {</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        m_ptrFirst = newNode;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        m_ptrLast = newNode;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    {</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        m_ptrLast-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a> = newNode;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a> = m_ptrLast;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        m_ptrLast = newNode;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    }</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    m_itemCount++;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;}</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160; </div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="comment">/* --------------------------------------------------------------------------------- PushAt */</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00278"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a0d4a62d13ed30fa3a38299c12a04a922">  278</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::PushAt</a>( T newItem, <span class="keywordtype">int</span> index )</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;{</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;PushAt&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <span class="keywordflow">if</span> ( index == 0 )</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    {</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        PushFront( newItem );</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    }</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( index == m_itemCount )</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    {</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        PushBack( newItem );</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    }</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( IsInvalidIndex( index ) )</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    {</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1InvalidIndexException.html">Exception::InvalidIndexException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::PushAt&quot;</span>, <span class="stringliteral">&quot;Invalid index!&quot;</span> );</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    }</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    {</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* ptrCurrent = m_ptrFirst;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160; </div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; index; i++ )</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        {</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            ptrCurrent = ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a>;</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        }</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160; </div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* before = ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a>;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* after  = ptrCurrent;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160; </div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* newNode = <span class="keyword">new</span> <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a459aed18dba2dd2715819449b41e8b90">m_data</a> = newItem;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160; </div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        before-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a> = newNode;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a> = after;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        after-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a> = newNode;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        newNode-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a> = before;</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160; </div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        m_itemCount++;</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    }</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;}</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160; </div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<span class="comment">/* ------------------------------------------------------------------------------- PopFront */</span></div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00353"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a34b0409cea3fd4c0a36f4eb8277ac928">  353</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::PopFront</a>()</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;{</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;PopFront&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    <span class="keywordflow">if</span> ( Size() == 0 )</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    {</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1StructureEmptyException.html">Exception::StructureEmptyException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::PopFront&quot;</span>, <span class="stringliteral">&quot;Cannot remove item from empty list!&quot;</span> );</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    }</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( Size() == 1 )</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    {</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;        <span class="keyword">delete</span> m_ptrFirst;</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        m_ptrFirst = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;        m_ptrLast = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    }</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    {</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        m_ptrFirst = m_ptrFirst-&gt;m_ptrNext;</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        <span class="keyword">delete</span> m_ptrFirst-&gt;m_ptrPrev;</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        m_ptrFirst-&gt;m_ptrPrev = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;    }</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160; </div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;    m_itemCount--;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;}</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160; </div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160; </div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;<span class="comment">/* -------------------------------------------------------------------------------- PopBack */</span></div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00412"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#acd8bb1487cb7c2a32fdbb1d254d61c01">  412</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::PopBack</a>()</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;{</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;PopBack&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    <span class="keywordflow">if</span> (Size() == 0)</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    {</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1StructureEmptyException.html">Exception::StructureEmptyException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::PopBack&quot;</span>, <span class="stringliteral">&quot;Cannot remove item from empty list!&quot;</span> );</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    }</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (Size() == 1)</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;    {</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="keyword">delete</span> m_ptrFirst;</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        m_ptrFirst = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;        m_ptrLast = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;    }</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    {</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* ptrOldLast = m_ptrLast;</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* ptrNewLast = m_ptrLast-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a>;</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160; </div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;        m_ptrLast = ptrNewLast;</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        <span class="keyword">delete</span> ptrOldLast;</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160; </div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;        m_ptrLast-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;    }</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160; </div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;    m_itemCount--;</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;}</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160; </div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160; </div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;<span class="comment">/* ---------------------------------------------------------------------------------- PopAt */</span></div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00478"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#aa4d17a7954ed30a575349f5f3207eb7d">  478</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::PopAt</a>( <span class="keywordtype">int</span> index )</div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;{</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;PopAt&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;    <span class="keywordflow">if</span> ( IsEmpty() )</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    {</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;    }</div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( IsInvalidIndex( index ) )</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;    {</div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1InvalidIndexException.html">Exception::InvalidIndexException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::PopAt&quot;</span>, <span class="stringliteral">&quot;Invalid index&quot;</span> );</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;    }</div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( index == 0 )</div>
<div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;    {</div>
<div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;        PopFront();</div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;    }</div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( index == m_itemCount - 1 )</div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;    {</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        PopBack();</div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;    }</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;    {</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* ptrCurrent = m_ptrFirst;</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160; </div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; index; i++ )</div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;        {</div>
<div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;            ptrCurrent = ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a>;</div>
<div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;        }</div>
<div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160; </div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* before = ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a>;</div>
<div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;        <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* after  = ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a>;</div>
<div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160; </div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;        before-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a> = after;</div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;        after-&gt;<a class="code" href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">m_ptrPrev</a> = before;</div>
<div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160; </div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;        <span class="keyword">delete</span> ptrCurrent;</div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;        m_itemCount--;</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;    }</div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;}</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160; </div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;<span class="comment">/* ------------------------------------------------------------------------------- GetFront */</span></div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00537"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a6983d67814ff741e4a6b651cbde45423">  537</a></span>&#160;T&amp; <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::GetFront</a>()</div>
<div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;{</div>
<div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;GetFront&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;    <span class="keywordflow">if</span> ( IsEmpty() )</div>
<div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;    {</div>
<div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1StructureEmptyException.html">Exception::StructureEmptyException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::GetFront&quot;</span>, <span class="stringliteral">&quot;List is empty!&quot;</span> );</div>
<div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;    }</div>
<div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160; </div>
<div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;    <span class="keywordflow">return</span> m_ptrFirst-&gt;m_data;</div>
<div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;}</div>
<div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160; </div>
<div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160; </div>
<div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;<span class="comment">/* -------------------------------------------------------------------------------- GetBack */</span></div>
<div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00568"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#ab3878e7ddfbd71111a72984d78c12f29">  568</a></span>&#160;T&amp; <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::GetBack</a>()</div>
<div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;{</div>
<div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;GetBack&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;    <span class="keywordflow">if</span> ( IsEmpty() )</div>
<div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;    {</div>
<div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1StructureEmptyException.html">Exception::StructureEmptyException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::GetBack&quot;</span>, <span class="stringliteral">&quot;List is empty!&quot;</span> );</div>
<div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;    }</div>
<div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160; </div>
<div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;    <span class="keywordflow">return</span> m_ptrLast-&gt;m_data;</div>
<div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;}</div>
<div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160; </div>
<div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160; </div>
<div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;<span class="comment">/* ---------------------------------------------------------------------------------- GetAt */</span></div>
<div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00608"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#ac83a29766c41a022c92d0e65a4086cfc">  608</a></span>&#160;T&amp; <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::GetAt</a>( <span class="keywordtype">int</span> index )</div>
<div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;{</div>
<div class="line"><a name="l00610"></a><span class="lineno">  610</span>&#160;<span class="comment">//    throw Exception::NotImplementedException( &quot;GetAt&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160;    <span class="keywordflow">if</span> ( IsInvalidIndex( index ) )</div>
<div class="line"><a name="l00612"></a><span class="lineno">  612</span>&#160;    {</div>
<div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160;        <span class="keywordflow">throw</span> <a class="code" href="classException_1_1InvalidIndexException.html">Exception::InvalidIndexException</a>( <span class="stringliteral">&quot;LinkedList&lt;T&gt;::GetAt&quot;</span>, <span class="stringliteral">&quot;Invalid index!&quot;</span> );</div>
<div class="line"><a name="l00614"></a><span class="lineno">  614</span>&#160;    }</div>
<div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160; </div>
<div class="line"><a name="l00616"></a><span class="lineno">  616</span>&#160;    <a class="code" href="structDoublyLinkedListNode.html">DoublyLinkedListNode&lt;T&gt;</a>* ptrCurrent = m_ptrFirst;</div>
<div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;    <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; index; i++ )</div>
<div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160;    {</div>
<div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;        ptrCurrent = ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">m_ptrNext</a>;</div>
<div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;    }</div>
<div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;    <span class="keywordflow">return</span> ptrCurrent-&gt;<a class="code" href="structDoublyLinkedListNode.html#a459aed18dba2dd2715819449b41e8b90">m_data</a>;</div>
<div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;}</div>
<div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160; </div>
<div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160; </div>
<div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;<span class="comment">/* -------------------------------------------------------------------------------- IsEmpty */</span></div>
<div class="line"><a name="l00630"></a><span class="lineno">  630</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00631"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#af17b5bce5a3f28d1ffe0f56f9c4430be">  631</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::IsEmpty</a>()<span class="keyword"> const</span></div>
<div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00633"></a><span class="lineno">  633</span>&#160;    <span class="keywordflow">return</span> ( m_itemCount == 0 );</div>
<div class="line"><a name="l00634"></a><span class="lineno">  634</span>&#160;}</div>
<div class="line"><a name="l00635"></a><span class="lineno">  635</span>&#160; </div>
<div class="line"><a name="l00636"></a><span class="lineno">  636</span>&#160; </div>
<div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160;<span class="comment">/* ----------------------------------------------------------------------------------- Size */</span></div>
<div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00643"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#a1f3d672a29c00423f8d17672a33d9ee5">  643</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::Size</a>()<span class="keyword"> const</span></div>
<div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;<span class="comment">//    throw NotImplementedException( &quot;Size&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;    <span class="keywordflow">return</span> m_itemCount;</div>
<div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;}</div>
<div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160; </div>
<div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;<span class="comment">/* -----------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;<span class="comment">/* ------------------------------------------------------------------------- IsInvalidIndex */</span></div>
<div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00658"></a><span class="lineno"><a class="line" href="classDataStructure_1_1LinkedList.html#abbc84d33dc78137ea638914b7af4f883">  658</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classDataStructure_1_1LinkedList.html">LinkedList&lt;T&gt;::IsInvalidIndex</a>( <span class="keywordtype">int</span> index )<span class="keyword"> const</span></div>
<div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;<span class="comment">//    throw NotImplementedException( &quot;IsInvalidIndex&quot; ); // Erase this once you work on this function</span></div>
<div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;    <span class="keywordflow">return</span> ( index &lt; 0 || index &gt;= m_itemCount );</div>
<div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;}</div>
<div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160; </div>
<div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;}</div>
<div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160; </div>
<div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructDoublyLinkedListNode_html_a4c8535395c5b58ff6d00a9759a86f21c"><div class="ttname"><a href="structDoublyLinkedListNode.html#a4c8535395c5b58ff6d00a9759a86f21c">DoublyLinkedListNode::m_ptrPrev</a></div><div class="ttdeci">DoublyLinkedListNode&lt; T &gt; * m_ptrPrev</div><div class="ttdef"><b>Definition:</b> LinkedListNode.h:12</div></div>
<div class="ttc" id="astructDoublyLinkedListNode_html_a459aed18dba2dd2715819449b41e8b90"><div class="ttname"><a href="structDoublyLinkedListNode.html#a459aed18dba2dd2715819449b41e8b90">DoublyLinkedListNode::m_data</a></div><div class="ttdeci">T m_data</div><div class="ttdef"><b>Definition:</b> LinkedListNode.h:14</div></div>
<div class="ttc" id="astructDoublyLinkedListNode_html_a6af4b06b53437a5bcecb5db276e5d9af"><div class="ttname"><a href="structDoublyLinkedListNode.html#a6af4b06b53437a5bcecb5db276e5d9af">DoublyLinkedListNode::m_ptrNext</a></div><div class="ttdeci">DoublyLinkedListNode&lt; T &gt; * m_ptrNext</div><div class="ttdef"><b>Definition:</b> LinkedListNode.h:11</div></div>
<div class="ttc" id="aclassException_1_1StructureEmptyException_html"><div class="ttname"><a href="classException_1_1StructureEmptyException.html">Exception::StructureEmptyException</a></div><div class="ttdoc">EXCEPTION for when a structure is empty.</div><div class="ttdef"><b>Definition:</b> StructureEmptyException.h:12</div></div>
<div class="ttc" id="aclassDataStructure_1_1LinkedList_html_ab34197960bb08dbc99a5860e6ce85017"><div class="ttname"><a href="classDataStructure_1_1LinkedList.html#ab34197960bb08dbc99a5860e6ce85017">DataStructure::LinkedList::m_ptrFirst</a></div><div class="ttdeci">DoublyLinkedListNode&lt; T &gt; * m_ptrFirst</div><div class="ttdoc">A pointer to the first item in the list.</div><div class="ttdef"><b>Definition:</b> LinkedList.h:34</div></div>
<div class="ttc" id="aclassDataStructure_1_1QueueTester_html"><div class="ttname"><a href="classDataStructure_1_1QueueTester.html">DataStructure::QueueTester</a></div><div class="ttdoc">TESTER for the Queue.</div><div class="ttdef"><b>Definition:</b> QueueTester.h:22</div></div>
<div class="ttc" id="aclassDataStructure_1_1LinkedList_html_a8054e1e07e5ef51ca22feb5c7791f174"><div class="ttname"><a href="classDataStructure_1_1LinkedList.html#a8054e1e07e5ef51ca22feb5c7791f174">DataStructure::LinkedList::m_ptrLast</a></div><div class="ttdeci">DoublyLinkedListNode&lt; T &gt; * m_ptrLast</div><div class="ttdoc">A pointer to the last item in the list.</div><div class="ttdef"><b>Definition:</b> LinkedList.h:36</div></div>
<div class="ttc" id="astructDoublyLinkedListNode_html"><div class="ttname"><a href="structDoublyLinkedListNode.html">DoublyLinkedListNode</a></div><div class="ttdoc">A node structure for a doubly linked list's node.</div><div class="ttdef"><b>Definition:</b> LinkedListNode.h:6</div></div>
<div class="ttc" id="aclassDataStructure_1_1ILinearDataStructure_html"><div class="ttname"><a href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a></div><div class="ttdoc">An interface of methods that our linear data structures should have.</div><div class="ttdef"><b>Definition:</b> ILinearDataStructure.h:12</div></div>
<div class="ttc" id="aclassException_1_1InvalidIndexException_html"><div class="ttname"><a href="classException_1_1InvalidIndexException.html">Exception::InvalidIndexException</a></div><div class="ttdoc">EXCEPTION for an invalid index detected.</div><div class="ttdef"><b>Definition:</b> InvalidIndexException.h:12</div></div>
<div class="ttc" id="aclassDataStructure_1_1LinkedList_html"><div class="ttname"><a href="classDataStructure_1_1LinkedList.html">DataStructure::LinkedList</a></div><div class="ttdef"><b>Definition:</b> LinkedList.h:29</div></div>
<div class="ttc" id="aLinkedListNode_8h_html"><div class="ttname"><a href="LinkedListNode_8h.html">LinkedListNode.h</a></div></div>
<div class="ttc" id="anamespaceDataStructure_html"><div class="ttname"><a href="namespaceDataStructure.html">DataStructure</a></div><div class="ttdef"><b>Definition:</b> ILinearDataStructure.h:7</div></div>
<div class="ttc" id="aclassDataStructure_1_1LinkedListTester_html"><div class="ttname"><a href="classDataStructure_1_1LinkedListTester.html">DataStructure::LinkedListTester</a></div><div class="ttdoc">TESTER for the LinkedList.</div><div class="ttdef"><b>Definition:</b> LinkedListTester.h:21</div></div>
<div class="ttc" id="aclassDataStructure_1_1StackTester_html"><div class="ttname"><a href="classDataStructure_1_1StackTester.html">DataStructure::StackTester</a></div><div class="ttdoc">TESTER for the Stack.</div><div class="ttdef"><b>Definition:</b> StackTester.h:21</div></div>
<div class="ttc" id="aclassDataStructure_1_1LinkedList_html_acf9282e10399d1caea2c8d661f39539f"><div class="ttname"><a href="classDataStructure_1_1LinkedList.html#acf9282e10399d1caea2c8d661f39539f">DataStructure::LinkedList::m_itemCount</a></div><div class="ttdeci">int m_itemCount</div><div class="ttdoc">The amount of items stored in the list.</div><div class="ttdef"><b>Definition:</b> LinkedList.h:38</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
